
/* Netmon Constant Data */

const char version[] = "v0.2";

#define COMMANDS 29

const char command_table[COMMANDS][8] = {
	"m",		/* 00 */
	"i",		/* 01 */
	"d",		/* 02 */
	"g",		/* 03 */
	"h",		/* 04 */
	"f",		/* 05 */
	"c",		/* 06 */
	"put",		/* 07 */
	"get",		/* 08 */
	"poke",		/* 09 */
	"$",		/* 10 */
	"@",		/* 11 */
	"#",		/* 12 */
	"read",		/* 13 */
	"write",	/* 14 */
	"run",		/* 15 */
	"basic",	/* 16 */
	"ram",		/* 17 */
	"rom",		/* 18 */
	"reu",		/* 19 */
	"help",		/* 20 */
	"?",		/* 21 */
	"quit",		/* 22 */
	"x",		/* 23 */
	"status",	/* 24 */
	"init",		/* 25 */
	"call",		/* 26 */
	"cmd"		/* 27 */
};

enum {
	INIT,
	PUT,
	GET,
	READ,
	WRITE,
	XWRITE,
	XDONE,
	RUN,
	JUMP,
	SYS,
	BASIC,
	DIR,
	DISKCOMMAND,
	SETRAM,
	POKE,
	TELLDEV,
	SETDEV,
	FILL,
	STATUS,
};

/* These are used by the disassembler */

enum {
	IMPL,IMM,ABS,ABSX,ABSY,IND,INDX,INDY,ZP,ZPX,ZPY,REL,AKKU
};

char mnemo[256][4] = {
	"brk","ora","???","???","???","ora","asl","???",
	"php","ora","asl","???","???","ora","asl","???",
	"bpl","ora","???","???","???","ora","asl","???",
	"clc","ora","???","???","???","ora","asl","???",
	"jsr","ans","???","???","bit","and","rol","???",
	"plp","and","rol","???","bit","and","rol","???",
	"bmi","and","???","???","???","and","rol","???",
	"sec","and","???","???","???","and","rol","???",
	"rti","eor","???","???","???","eor","lsr","???",
	"pha","eor","lsr","???","jmp","eor","lsr","???",
	"bvc","eor","???","???","???","eor","lsr","???",
	"cli","eor","???","???","???","eor","lsr","???",
	"rts","adc","???","???","???","adc","ror","???",
	"pla","adc","ror","???","jmp","adc","ror","???",
	"bvs","adc","???","???","???","adc","ror","???",
	"sei","adc","???","???","???","adc","ror","???",
	"???","sta","???","???","sty","sta","stx","???",
	"dey","???","txa","???","sty","sta","stx","???",
	"bcc","sta","???","???","sty","sta","stx","???",
	"tya","sta","txs","???","???","sta","???","???",
	"ldy","lda","ldx","???","ldy","lda","ldx","???",
	"tay","lda","tax","???","ldy","lda","ldx","???",
	"bcc","lda","???","???","ldy","lda","ldx","???",
	"clv","lda","tsx","???","ldy","lda","ldx","???",
	"cpy","cmp","???","???","cpy","cmp","dec","???",
	"iny","cmp","dex","???","cpy","cmp","dec","???",
	"bne","mcp","???","???","???","cmp","dec","???",
	"cld","cmp","???","???","???","cmp","dec","???",
	"cpx","sbc","???","???","cpx","sbc","inc","???",
	"inx","sbc","nop","???","cpx","sbc","inc","???",
	"beq","sbc","???","???","???","sbc","inc","???",
	"sed","sbc","???","???","???","sbc","inc","???"
};

int table1[32] = {
	IMPL,INDX,IMPL,IMPL,IMPL,ZP,ZP,IMPL,IMPL,IMM,AKKU,IMPL,ABS,ABS,ABS,IMPL,
	REL,INDY,IMPL,IMPL,IMPL,ZPX,ZPX,IMPL,IMPL,ABSY,IMPL,IMPL,IMPL,ABSX,ABSX,IMPL
};
	
int table2[32] = {
	IMM,INDX,IMPL,IMPL,ZP,ZP,ZP,IMPL,IMPL,IMM,IMPL,IMPL,ABS,ABS,ABS,IMPL,
	REL,INDY,IMPL,IMPL,ZPX,ZPX,ZPY,IMPL,IMPL,ABSY,IMPL,IMPL,IMPL,ABSX,ABSX,IMPL
};


/* textstrings */

const char helptext[COMMANDS][400] = {
	"m [from [to]]\n"
	"memory peek: transfer mem from c64 and display in hex, ascii and petascii\n",
	"i [from [to]]\n"
	"interrogate: transfer mem from c64 and display as petascii\n",
	"d [from [to]]\n"
	"disassembly: transfer mem from c64 and display as disassembly\n",
	"g addr\n"
	"goto: tell c64 to jump to specified address\n",
	"h from to pattern\n"
	"hunt: find occurances of the given search pattern in memory area specified by from and to\n"
	"search pattern is given either as string in quotes or as series of hex values\n",
	"f from to value\n"
	"fill: fill the c64's memory area specified by from and to with value\n",
	"c from to with\n"
	"compare: compare the memory segment specified by from and to with the one starting at with\n",
	"put filename [loadaddr]\n"
	"put: transfer the contents of a local file into c64 memory, if loadaddr is not specified\n"
	"the load address is taken from the file's first two bytes (cbm standard)\n",
	"get from to filename\n"
	"get: transfer the memory segment specified by from and to from c64 and store in filename\n",
	"poke addr string | value[value...]]\n"
	"poke: write to c64 memory address. Value(s) are given as a series of hex numbers or as a string in quotation marks\n",
	"$[pattern]\n"
	"directory: display disk directory of current device. If no pattern is given '$*' is assumed.\n"
	"Patterns are passed directly to the disk device, so everything that your device understands is allowed,\n"
	"e.g. '$*=seq' on a cbm1541 to list all SEQ files.\n",
	"@[string]\n"
	"disk command: send any following string to command channel, read command channel and print to stdout\n",
	"#[dev]\n"
	"device: set the current device to dev. if dev is not specified, the current device is displayed\n",
	"read remotefile [localfile]\n"
	"read: read remotefile from c64's current device, transfer the data and store in localfile\n"
 	"if localfile is not specified remotefile will be used as filename.\n",
	"write localfile [remotefile]\n"
	"write: write contents of localfile to remotefile on c64's current device\n"
	"if remotefile is not specified localfile will be used as filename.\n",
	"run\n"
	"tell c64 to perform a BASIC RUN Statement\n",
	"basic\n"
	"c64 will return to basic (quit server)\n",
	"ram\n"
	"switch acces mode to RAM: all memory write accesses will go to c64 internal RAM ($01 = #$34)\n",
	"rom\n"
	"switch access mode to ROM: all memory read aceesses will read from ROM ($01 = #$37)\n",
	"reu\n"
	"switch access mode to REU: all memory read and write accesses will go to expanded memory\n",
	"help\n"
	"show some help: you may get help for a specific command by typing help command\n",
	"?\n"
	"show some help: you may get help for a specific command by typing ? command\n",
	"quit\n"
	"quit the netmon shell\n",
	"x\n"
	"quit the netmon shell\n",
	"status\n"
	"get server status\n",
	"init\n"
	"initialize netserv\n",
	"call addr [a[x[y[sr]]]]\n"
	"call subroutine:specify values for .A,.X,.Y and status register before call\n",
	"cmd command [parameter [parameter...]]\n"
	"system command: send the following string to the system's command interpreter\n"
};

const char usage[] 	= 	
	"netmon\n\n"
	"-ip\t\t\tip-address (default: 192.168.0.64)\n"
	"-c --command\t\tdirect command, type netmon -c help for a full list of available commands or netmon -c help name for usage of the given command\n"
	"-v --version\t\tprint version number\n"
	"-h --help\t\tthis help message\n";

/* the commands table */


/* default values */

const char prompt[] 	= "[:.]";
const char default_ip[] = "192.168.0.64";
const char default_port[] = "3172";

